Unit de11e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTDE11_p;

procedure de11e(F :Proc_FE_DE; M :Integer; XN :Extended;
                var YN :Array of Extended; XK :Extended; HMIN :Extended;
                EPS :Extended; P :Extended; var H :Extended;
                var Y :Array of Extended; var YP :Array of Extended;
                var DELTY :Array of Extended; var RAB :Array of Extended;
                var IERR :Integer);

implementation

procedure de11e(F :Proc_FE_DE; M :Integer; XN :Extended;
                var YN :Array of Extended; XK :Extended; HMIN :Extended;
                EPS :Extended; P :Extended; var H :Extended;
                var Y :Array of Extended; var YP :Array of Extended;
                var DELTY :Array of Extended; var RAB :Array of Extended;
                var IERR :Integer);
var
E,BA :Integer;
B,C,W,X,Z,BD,BG :Extended;
A,BB,BUL :Boolean;
L :Array [0..1] of Extended;
const
N :Extended = 0.5e0;
O :Extended = 0.5e0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23;
begin
{   DATA  FORTRAN  }
L[0] := 0.0e0;
L[1] := 1.0e0;
IERR := 0;
B := 8.0e0;
C := XN;
for E:=1 to M do
 begin
  Y[E-1] := YN[E-1];
_1:
 end;
if ( XN = XK ) 
 then goto _23;
A := False;
BUL := False;
H := Sign(H,XK-XN);

_2:
if ( not A ) 
 then goto _3;
H := W;

goto _23;
_3:
X := XK-C;
if ( Abs(X) > Abs(H) ) 
 then goto _4;
W := H;
A := True;
H := X;
_4:
Z := C;
BA := 1;
for E:=1 to M do
 begin
  YP[E-1] := Y[E-1];
_5:
 end;
goto _11;
_6:
for E:=1 to M do
 begin
  DELTY[E-1] := Y[E-1];
  Y[E-1] := YP[E-1];
_7:
 end;
C := Z;
H := H*0.5e0;
BA := 2;
goto _11;
_8:
BA := 3;
goto _11;
_9:
for E:=1 to M do
 begin
  DELTY[E-1] := (Y[E-1]-DELTY[E-1])/3.0e0;
  Y[E-1] := Y[E-1]+DELTY[E-1];
_10:
 end;
H := 2.0e0*H;
goto _17;

_11:
BG := C;
for E:=1 to M do
 begin
  RAB[(E-1)+1*M] := Y[E-1];
_12:
 end;
F(C,RAB[0+1*M],RAB[0+0*M],M);
for E:=1 to M do
 begin
  RAB[(E-1)+0*M] := RAB[(E-1)+0*M]*H;
_13:
 end;
for E:=1 to M do
 begin
  RAB[(E-1)+1*M] := Y[E-1]+N*RAB[(E-1)+0*M];
_14:
 end;
C := BG+O*H;
for E:=1 to M do
 begin
  Y[E-1] := Y[E-1]+L[0]*RAB[(E-1)+0*M];
_15:
 end;
F(C,RAB[0+1*M],RAB[0+0*M],M);
for E:=1 to M do
 begin
  Y[E-1] := Y[E-1]+L[1]*RAB[(E-1)+0*M]*H;
_16:
 end;
C := BG+H;
case BA of
 1: goto _6;
 2: goto _8;
 3: goto _9;
end;
_17:
BB := True;
for E:=1 to M do
 begin
  BD := Abs(Y[E-1]);
  if ( BD < P ) 
   then goto _18;
  DELTY[E-1] := DELTY[E-1]/Y[E-1];
_18:
 end;
for E:=1 to M do
 begin
  BD := Abs(DELTY[E-1]);
  if ( BD > EPS ) 
   then goto _20;
  if ( not BB ) 
   then goto _19;
  if ( B*BD < EPS ) 
   then goto _19;
  BB := False;
_19:
 end;
if ( not BB ) 
 then goto _2;
H := H+H;
BUL := False;
goto _2;
_20:
for E:=1 to M do
 begin
  Y[E-1] := YP[E-1];
_21:
 end;
if ( BUL ) 
 then goto _22;
C := C-H;
H := 0.5e0*H;
A := False;
if ( Abs(H) >= HMIN ) 
 then goto _4;
H := Sign(HMIN,H);
BUL := True;
goto _4;
_22:
IERR := 65;
UTDE11(IERR,11);
_23:
end;

end.
